#!/bin/bash

chemin="$(cd "$(dirname "$0")";pwd)"

# il faut se déplacer dans le dossier de l'interface ou indiquer le path entier du glade.
cd "${chemin}"

#########################
##### Pre lancement #####
#########################
config="${HOME}/.config/mkv-extractor-gui/config.cfg"

# S'il y a un argument, on verfie que c'est un fichier et on modifie le fichier de config
[[ -f "${@}" ]] && sed -i "s^_fichier_mkv = .*^_fichier_mkv = ${@//\'/\'}^" "${config}"


function config
{
# Creation du dossier de config s'il n'existe pas
[[ ! -d "${config%/*}" ]] && mkdir -p "${config%/*}"

# Création des variables contenues dans le fichier de config
[[ ! -e "${config}" || ! -s "${config}" ]] && echo "[TOGGLE]
_canaux = False
_fichier_tmp = True
_auto_save = False
_auto_file = False
_remplacer = False
_open_sub = False

[WINDOW:_window1]
width = -1
height = -1
x = -1
y = -1

[COMBO]
_bitrate = 0
_langue = 1
_boost = 0

[ENTRY]
_fichier_mkv =
_dossier_save = ${HOME}" > "${config}"


#######################
##### Traductions #####
#######################
#Pour exporter la librairie de gettext
set -a
source gettext.sh
set +a

case $(sed -n '/_langue/ s/.*= //p' "${config}") in
	0) export LANGUAGE=cz ;;
	1) export LANGUAGE=en ;;
	2) export LANGUAGE=fr ;;
esac

export TEXTDOMAIN=mkv-extractor-gui
export TEXTDOMAINDIR="${chemin}/locale"
. gettext.sh

# xgettext -o mkv-extractor-gui.pot mkv-extractor-gui.glade *.sh --from-code UTF-8; mv mkv-extractor-gui.pot locale/fr/; cd locale/fr/; msgmerge -o new_mkv-extractor-gui.po mkv-extractor-gui.po mkv-extractor-gui.pot; rm mkv-extractor-gui.pot mkv-extractor-gui.po; mv new_mkv-extractor-gui.po mkv-extractor-gui.po

# msgfmt mkv-extractor-gui.po -o mkv-extractor-gui.mo; cp mkv-extractor-gui.mo LC_MESSAGES; mv mkv-extractor-gui.mo ../../../locale/fr/LC_MESSAGES/; cd ../../

#xgettext -o mkv-extractor-gui.pot mkv-extractor-gui.glade *.sh --from-code UTF-8
#msgmerge -o new_mkv-extractor-gui.po mkv-extractor-gui.po mkv-extractor-gui.pot
#msginit -i mkv-extractor-gui.pot -o mkv-extractor-gui.po
#msgfmt mkv-extractor-gui.po -o mkv-extractor-gui.mo
}

###############################
##### Lancement graphique #####
###############################
while true
do
	# Execution de la fonction gérant le fichier de config
	config

	# Lancement de la fenetre glade via glade2script
	./mkv-extractor-gui.py -d -g ./mkv-extractor-gui.glade \
--auto-config="${config}" \
--tree "@@liste_pistes@@CHECK%%$(eval_gettext $'Choice')|ICON%%5%%$(eval_gettext $'Type')|HIDE|ICON%%5%%$(eval_gettext $'View')%%clic|$(eval_gettext $'Name/Resolution/Frequency')%%editable|COMBO%%$(eval_gettext $'Language/fps/weight/channels')%%Exemples :%%25.000 fps%%23.976 fps%%30.000 fps%%fra%%eng%%jpn|HIDE" \
--infobulle="@@liste_pistes@@1:6" \
--combobox='@@_bitrate@@col
128 kbits/seconde
192 kbits/seconde
224 kbits/seconde
256 kbits/seconde
320 kbits/seconde
384 kbits/seconde
448 kbits/seconde
512 kbits/seconde
576 kbits/seconde
640 kbits/seconde' \
--combobox='@@_boost@@col
0 : Pas de changement
256 : Puissance x 2
512 : Puissance x 3
768 : Puissance x 4
1024 : Puissance x 5' \
--combobox='@@_langue@@col|IMG%%22
Český|flags/CZ.png
English|flags/EN.png
Français|flags/FR.png'

	#EXIT@SAVE => EXIT="yes" => code retour=0 => arret
	#EXIT@ => EXIT="no" => code retour=1 => restart
	[[ ${?} == 1 ]] && break
done

#####################################
##### Menage dans les processus #####
#####################################
PIDS=$(pstree -p $$) PIDS=${PIDS//[!0-9]/$'\n'} PIDS=$(sed '/^$/d' <<< "${PIDS}") PIDS=${PIDS#*$'\n'} PIDS=$(sort -nr <<< "${PIDS}") PIDS=${PIDS//$'\n'/ }

# Creation d'un fichier qui killera tous les processus
echo '#!/bin/bash
for pid in '${PIDS}'; do [[ $(ps h ${pid}) ]] && kill ${pid}; done
sleep 0.5
while [[ $(pstree | grep "mkv-extractor-g") && -z $(pstree | grep "go_mkv-extracto") ]]
do
	killall -9 mkv-extractor-gui.sh
	sleep 0.2
done

[[ -d /tmp/mkv-extractor-gui/ ]] && rm -r /tmp/mkv-extractor-gui/

rm /tmp/kill_mkv-extractor-gui' > /tmp/kill_mkv-extractor-gui

# lancement du script killer
bash /tmp/kill_mkv-extractor-gui &

exit
